#include "utils.h"
#include "./mpreal.h"

using namespace Util;

rgb::rgb(uint8_t r, uint8_t g, uint8_t b)
         : r(r), g(g), b(b)
{
}

Vec2i::Vec2i(int x, int y) : x(x), y(y)
{
}

Vec2f::Vec2f(float x, float y) : x(x), y(y)
{
}

Vec2d::Vec2d(double x, double y) : x(x), y(y)
{
}

//BigFloat::BigFloat(uint32_t prec) : precision(prec)
//{
//    mpfr_init2(this->val, prec);
//}
//
//BigFloat::~BigFloat()
//{
//    //if (this->val->_mpfr_d != nullptr)
//    //    mpfr_clear(this->val);
//}
//
//BigFloat BigFloat_d(double d, uint32_t prec)
//{
//    BigFloat bf = BigFloat(prec);
//    bf.setValue(d);
//
//    return bf;
//}
//
//BigFloat BigFloat::abs(const BigFloat &bf)
//{
//    BigFloat r = BigFloat(bf.precision);
//
//    mpfr_abs(r.val, bf.val, MPFR_RNDD);
//
//    return r;
//}
//void BigFloat::setValue(double val)
//{
//    mpfr_set_d(this->val, val, MPFR_RNDD);
//}
//
//std::string BigFloat::to_str() const
//{
//    char buf[this->precision/2];
//
//    mpfr_snprintf(buf, this->precision/2, "%.60RNf", this->val);
//
//    std::string s(buf);
//
//    return s;
//}

void init(uint32_t prec)
{
//    mpfr::mpreal::set_default_prec(prec);
}

Vec2mp::Vec2mp(mpfr::mpreal x, mpfr::mpreal y)
               : x(x), y(y)
{
}

Vec2mp::Vec2mp(double x, double y)
               : x(mpfr::mpreal(x)), y(mpfr::mpreal(y))
{
}
/*
BigFloat operator + (BigFloat const &f);
BigFloat operator - (BigFloat const &f);
BigFloat operator * (BigFloat const &f);
BigFloat operator / (BigFloat const &f);
*/
